
extern int pbc_int(int i,int N);

extern real *** CreateCubic_pme(int rows,int cols,int lays);


extern real * CreateCubic2(int rows,int cols,int lays);


extern real * CreateMatrix2(int rows,int cols);


extern real * CreateVector2(int rows);


extern double * CreateVector2Double(int rows);


extern float * CreateVector2Float(int rows);


extern int * CreateVector2Int(int rows);


extern float pmecalcFSR(float z2);


extern void getPot3D(gmx_pme_t pme, real *grid, pme_atomcomm_t *atc, real rcutoff, matrix box, int *potgrid, real *externpotSum, real *externpotReal, real *externpotRec, real ewaldcoeff);

extern void getPhiOfElectrode(gmx_pme_t pme, real *grid, pme_atomcomm_t *atc, pme_atomcomm_t *atcForSpline, real rcutoff, matrix box, real ewaldcoeff, int NUserSelectGrid,
					    real *UserSelectPosition, real *UserSetPot, real *externElectrodePot, real *externElectrodeReal, real *externElectrodeRec);						

extern void getChargeOfElectrode(gmx_pme_t pme, int NUserSelectGrid, float  *inv_MatrixA, real *externElectrodePot, double *externElectrodeCharge, real *chargeA, real *Phiofelectrode_cc);


extern void force_callz(gmx_pme_t pme, real *grid, pme_atomcomm_t *atc, real rcutoff, matrix box, real ewaldcoeff, int NUserSelectGrid, 
						real *UserSelectPosition, real *UserSetPot, real *externElectrodePot, real *externElectrodeReal, real *externElectrodeRec, real *chargeA);


extern void getPhiOfElectrodeRerun(gmx_pme_t pme, int NUserSelectGrid, float *MatrixA, real *electrodeReal, real *electrodeRec, 
							double *electrodeCharge, double *externAllElectrodePot, double *externAvePosPot, double *externAveNegPot);


extern void getPhiOfBulk(gmx_pme_t pme, real *grid, pme_atomcomm_t *atc, matrix box, real *boundary, double *externBulkPot);
